Index: LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90	(revision 1864)
@@ -33,4 +33,5 @@
     integer i, k, band, wave
     integer, save :: mth_pre
+!$OMP THREADPRIVATE(mth_pre)
 
     real, allocatable, dimension(:,:), save :: tau_aer_strat
@@ -41,5 +42,4 @@
     real, allocatable:: tauaerstrat_mois(:, :, :)
     real, allocatable:: tauaerstrat_mois_glo(:, :)
-    real, allocatable:: tauaerstrat_mois_glo_bands(:,:,:)
 
 ! For NetCDF:
@@ -61,7 +61,8 @@
     IF (.not.ALLOCATED(tau_aer_strat)) ALLOCATE(tau_aer_strat(klon,klev))
 
+!--only read file if beginning of run or start of new month
+    IF (debut.OR.mth_cur.NE.mth_pre) THEN
+
     IF (is_mpi_root) THEN
-
-    IF (debut.OR.mth_cur.NE.mth_pre) THEN
 
     IF (nbands.NE.2) THEN 
@@ -107,8 +108,7 @@
     ENDIF
 
-    ALLOCATE(tauaerstrat(n_lon, n_lat, n_lev, n_month))
-    ALLOCATE(tauaerstrat_mois(n_lon, n_lat, n_lev))
-    ALLOCATE(tauaerstrat_mois_glo(klon_glo, n_lev))
-    ALLOCATE(tauaerstrat_mois_glo_bands(klon_glo, n_lev,nbands))
+    IF (.not.ALLOCATED(tauaerstrat))          ALLOCATE(tauaerstrat(n_lon, n_lat, n_lev, n_month))
+    IF (.not.ALLOCATED(tauaerstrat_mois))     ALLOCATE(tauaerstrat_mois(n_lon, n_lat, n_lev))
+    IF (.not.ALLOCATED(tauaerstrat_mois_glo)) ALLOCATE(tauaerstrat_mois_glo(klon_glo, n_lev))
 
 !--reading stratospheric AOD at 550 nm
@@ -128,21 +128,23 @@
     CALL grid2dTo1d_glo(tauaerstrat_mois,tauaerstrat_mois_glo)
 
+!    DEALLOCATE(tauaerstrat)
+!    DEALLOCATE(tauaerstrat_mois)
+!    DEALLOCATE(tauaerstrat_mois_glo)
+  
+    ENDIF !--is_mpi_root
+
 !--scatter on all proc
     CALL scatter(tauaerstrat_mois_glo,tau_aer_strat)
 
-    DEALLOCATE(tauaerstrat)
-    DEALLOCATE(tauaerstrat_mois)
-    DEALLOCATE(tauaerstrat_mois_glo)
-  
+!--keep memory of previous month
     mth_pre=mth_cur
 
     ENDIF !--debut ou nouveau mois
 
-    ENDIF !--is_mpi_root
-
 !--total vertical aod at the 5 wavelengths
     DO wave=1, nwave
     DO k=1, klev
-    tausum_aero(:,wave,id_strat)=tausum_aero(:,wave,id_strat)+tau_aer_strat(:,k)*alpha_strat_wave(wave)/alpha_strat_wave(2)
+    tausum_aero(:,wave,id_STRAT)=tausum_aero(:,wave,id_STRAT)+tau_aer_strat(:,k)*alpha_strat_wave(wave)/alpha_strat_wave(2)
+!    tausum_aero(:,wave,id_ASBCM)=tausum_aero(:,wave,id_ASBCM)+tau_aer_strat(:,k)*alpha_strat_wave(wave)/alpha_strat_wave(2)
     ENDDO
     ENDDO
Index: LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/traclmdz_mod.F90	(revision 1864)
@@ -337,5 +337,5 @@
   SUBROUTINE traclmdz(nstep, julien, gmtime, pdtphys, t_seri, paprs, pplay, &
        cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon, couchelimite, sh, &
-       rh, pphi, ustar, zu10m, zv10m, &
+       rh, pphi, ustar, wstar, ale_bl, ale_wake,  zu10m, zv10m, &
 !!          tr_seri, source, solsym, d_tr_cl, zmasse)                      !RomP
           tr_seri, source, solsym, d_tr_cl,d_tr_dec, zmasse)               !RomP
@@ -385,4 +385,5 @@
     REAL,DIMENSION(klon,klev),INTENT(IN) :: pphi    ! geopotentie
     REAL,DIMENSION(klon),INTENT(IN)      :: ustar   ! ustar (m/s)
+    REAL,DIMENSION(klon),INTENT(IN)      :: wstar,ale_bl,ale_wake   ! wstar (m/s) and Avail. Lifti. Energ.
     REAL,DIMENSION(klon),INTENT(IN)      :: zu10m   ! vent zonal 10m (m/s)
     REAL,DIMENSION(klon),INTENT(IN)      :: zv10m   ! vent zonal 10m (m/s)
Index: LMDZ5/branches/testing/libf/phylmd/write_histrac.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/write_histrac.h	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/write_histrac.h	(revision 1864)
@@ -45,5 +45,5 @@
 
 ! TD COUCHE-LIMITE
-      IF (couchelimite) THEN
+      IF (iflag_vdf_trac>=0) THEN
         CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_cl_"//tname(iiq),itau_w,d_tr_cl(:,:,it))
         CALL histwrite_phy(nid_tra,.FALSE.,"d_tr_dry_"//tname(iiq),itau_w,d_tr_dry(:,it))
